<template>
  <div>
    <div class="form-without-border">
      <span style="color:red;padding-left:20px;">{{ lengthError }}</span>
      <div class="card-body d-flex justify-content-between py-2">
        <div class="input-group">
          <input type="text" class="form-control" :placeholder="$t('search')" v-model="form.search" v-on:keyup.enter="searchDatacatalog">
          <div class="input-group-append">
            <button @click="showAdvancedSearch" class="btn" style="border: 1px solid black"><font-awesome-icon icon="sliders-h"/></button>
            <button @click="searchDatacatalog" class="btn btn-outline-success">{{ $t('send') }}</button>
            <button @click="resetForm" class="btn btn-outline-secondary">{{ $t('reset') }} </button>
          </div>
        </div>
      </div>
      <div v-show="advancedSearchShow" class="card advanced-search blue" :style="customColorStyle">
        <div class="card-body p-4 top-minus">
          <div class="container">
            <div class="row">
              <div class="col">
                <label>{{ $t('name') }}</label>
                <input
                  v-model="form.name"
                  type="text" class="form-control rounded"
                  :placeholder="$t('name')"/>
              </div>
              <div class="col">
                <label>{{ $t('column') }}</label>
                <input
                  v-model="form.col"
                  type="text" class="form-control rounded"
                  :placeholder="$t('column')"/>
              </div>
              <div class="col">
                <label>{{ $t('description') }}</label>
                <input
                  v-model="form.description"
                  type="text" class="form-control rounded"
                  :placeholder="$t('description')"/>
              </div>
              <div class="col">
                <label>{{ $t('label') }}</label>
                <input
                  v-model="form.labels"
                  type="text" class="form-control rounded"
                  :placeholder="$t('label')"/>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-md-4 mb-3">
              <label>{{ $t('system') }}</label>
              <div class="dropdown">
                <select class="form-control" v-model="form.system">
                  <option v-bind:key="item.id" v-for="item in optSystem" v-bind:value="item.id">{{ item.libelle }}</option>
                </select>
              </div>
            </div>
            <div class="col-md-4 mb-3">
              <label>{{ $t('type-data') }}</label>
              <div class="dropdown">
                <select class="form-control" v-model="form.dataType">
                  <option v-bind:key="item.id" v-for="item in optDataType" v-bind:value="item.id">{{ item.libelle }}</option>
                </select>
              </div>
            </div>
            <div class="col-md-4 mb-3">
              <label>{{ $t('strategy-tag') }}</label>
              <input
                v-model="form.tagStrategy"
                type="text" class="form-control rounded"
                :placeholder="$t('strategy-tag')"/>
            </div>
          </div>
          <div class="row">
            <div class="col-md-4 mb-3">
              <label>{{ $t('tag-template') }}</label>
              <div class="dropdown">
                <select class="form-control" v-model="form.tagModel">
                  <option v-bind:key="item.id" v-for="item in optTagModel" v-bind:value="item.id">{{ item.libelle }}</option>
                </select>
              </div>
            </div>
            <div class="col-md-4 mb-3">
              <label>{{ $t('dataset') }}</label>
              <div class="dropdown">
                <select :options="optDataset" class="form-control" v-model="form.dataset">
                  <option v-bind:key="item.id" v-for="item in optDataset" v-bind:value="item.id">{{ item.libelle }}</option>
                </select>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import APISearch from '@/api/search'
import APIGcp from '@/api/gcp'
import Vue from 'vue'
import custom from '@/shared/custom'
export default {
  data () {
    return {
      advancedSearchShow: false,
      form: {
        search: null,
        name: null,
        col: null,
        description: null,
        labels: null,
        tagStrategy: null,
        system: '*',
        dataType: '*',
        tagModel: '*',
        dataset: '*'
      },
      optTagModel: [],
      optDataset: [],
      optProject: [],
      optDataType: [],
      optSystem: [],
      lengthError: '',
      notNullValueAfterReset: ['system', 'dataType', 'tagModel', 'dataset']
    }
  },
  methods: {
    showAdvancedSearch () {
      this.advancedSearchShow = !this.advancedSearchShow
    },
    filterListByDispo (list) {
      if (list) {
        return list.filter(item => item.disponible === true)
      } else {
        return null
      }
    },
    searchDatacatalog () {
      this.$store.commit('saveLoading', true)
      this.changeValue(null, '*')
      if (this.form.search.length > 2) {
        this.lengthError = null
        Vue.prototype.$formSearch = this.form
        APISearch.searchDatacatalog(this.form).then(response => {
          Vue.prototype.$responseSearch = response
          this.$store.commit('saveLoading', false)
          this.$emit('event-results-search')
        }).catch(() => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
        })
      } else {
        this.$store.commit('saveLoading', false)
        this.lengthError = this.$t('length-error')
      }
      this.changeValue('*', null)
    },
    initForm () {
      if (this.$formSearch) {
        this.form = this.$formSearch
      }
    },
    changeValue (valToCheck, valToChange) {
      for (var field in this.form) {
        if (this.notNullValueAfterReset.indexOf(field) === -1) {
          this.form[field] = this.form[field] !== valToCheck ? this.form[field] : valToChange
        }
      }
    },
    resetForm () {
      this.$emit('event-reset-results-search')
      this.lengthError = ''
      for (var field in this.form) {
        if (this.notNullValueAfterReset.indexOf(field) !== -1) {
          this.form[field] = '*'
        } else {
          this.form[field] = null
        }
      }
    },
    addAllToList (list) {
      list.unshift({
        id: '*',
        libelle: this.$t('all'),
        disponible: true
      })
      return list
    },
    getAllTagModels () {
      this.$store.commit('saveLoading', true)
      const optTagModel = []
      APIGcp.getTagModelsWithoutProjectName().then(response => {
        response.forEach(item => {
          optTagModel.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optTagModel = this.addAllToList(optTagModel)
        this.optTagModel = this.filterListByDispo(this.$optTagModel)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllDataType () {
      this.$store.commit('saveLoading', true)
      const dataTypes = []
      APIGcp.getDataTypes().then(response => {
        response.forEach(item => {
          dataTypes.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optDataType = this.addAllToList(dataTypes)
        this.optDataType = this.filterListByDispo(this.$optDataType)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllSystem () {
      this.$store.commit('saveLoading', true)
      const systems = []
      APIGcp.getTypeSystems().then(response => {
        response.forEach(item => {
          systems.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optSystem = this.addAllToList(systems)
        this.optSystem = this.filterListByDispo(this.$optSystem)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllDatasets () {
      this.$store.commit('saveLoading', true)
      const datasets = []
      APIGcp.getTDatasets().then(response => {
        response.forEach(item => {
          datasets.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$datasets = this.addAllToList(datasets)
        this.optDataset = this.filterListByDispo(this.$datasets)
        this.$store.commit('saveLoading', false)
      })
    },
    getLoadedFilters () {
      this.optDataset = this.filterListByDispo(this.$datasets)
      this.optTagModel = this.filterListByDispo(this.$optTagModel)
      this.optDataType = this.filterListByDispo(this.$optDataType)
      this.optSystem = this.filterListByDispo(this.$optSystem)
      const isAllLoad = (this.optTagModel && this.optTagModel && this.optSystem && this.optDataType)
      if (!isAllLoad) {
        if (!this.optTagModel) {
          this.getAllTagModels()
        }
        if (!this.optDataset) {
          this.getAllDatasets()
        }
        if (!this.optDataType) {
          this.getAllDataType()
        }
        if (!this.optSystem) {
          this.getAllSystem()
        }
      }
    }
  },
  computed: {
    customColorStyle () {
      return custom.customColorStyle()
    }
  },
  created () {
    this.getLoadedFilters()
    if (!this.$responseSearch) {
      Vue.prototype.$responseSearch = []
    }
  }
}
</script>

<style scoped>
.form-without-border {
  margin: 0 7% 0 7%;
  padding-bottom: 20px;
}
.advanced-search {
  margin: -8px 2% 0 2%;
}
label{
  margin-top: 15px;
}
.top-minus {
  margin-top: -20px;
}
.container {
  padding: 0;
  margin: 0;
  width: 100%;
  max-width: 100%;
}
</style>
